program xyscale;
uses crt,dos;
const
        data_margen = 0.5;
var
        yy,mm,dd,daguge     : word;
        i,code,hour         : integer;
        date,datehr         : longint;
        x,y,xmin,xmax,ymin,ymax : single;
        name,Str            : string ;
        str8                : string[8];
        ch1                 : string[1] ;
        infile,outfile      : text;
        Suppl_txt           : Boolean;

begin
  Suppl_txt := false;
  if paramcount>1 then begin
    name := paramstr(1);
    if (paramstr(2)='y') or (paramstr(2)='Y') then Suppl_txt:= true;
  end else begin
    clrscr;
    writeln('-------------------------------------------------------------');
    writeln('       XY-plot of concentrations from Kincaid.               ');
    writeln('                                                             ');
    writeln('   Batch:                                                    ');
    writeln('     XYSCALE "yymmddhr".dat y/n a/(xmin xmax ymin ymax)      ');
    writeln('   where                                                     ');
    writeln('     "yymmddhr".dat : File name.                             ');
    writeln('      y/n           : Current date on plot.                  ');
    writeln('      a/(xmin ...)  : Axis limits: Automatic or user data.   ');
    writeln('                                                             ');
    writeln('                               NERI, Per Lfstrm, 20/9-93.  ');
    writeln('-------------------------------------------------------------');
    writeln;
    write('  Enter file name ("YYMMDDHR".DAT) of dataset: ');
    readln(name);
  end;
  assign(infile,name);
  reset(infile);

  str8 := '        ';
  for i:=1 to 8 do
    str8[i] := name[i];
  val(str8,datehr,code);
  date := datehr div 100;
  hour := datehr - date*100;

  xmax := 0;
  xmin := 0;
  ymax := 0;
  ymin := 0;
  repeat
    readln(InFile,x,y);
    if (x>xmax) then xmax := x;
    if (x<xmin) then xmin := x;
    if (y>ymax) then ymax := y;
    if (y<ymin) then ymin := y;
  Until eof(infile);
  writeln;
  writeln('  Range of data:');
  writeln('     x-coordinate: ',xmin:5:0,' - ',xmax:3:0,' km');
  writeln('     y-coordinate: ',ymin:5:0,' - ',ymax:3:0,' km');
  xmax := int(xmax + data_margen);
  if xmax>0 then xmax := xmax +1;
  ymax := int(ymax + data_margen);
  if ymax>0 then ymax := ymax +1;
  xmin := int(xmin - data_margen);
  if xmin<0 then xmin := xmin -1;
  ymin := int(ymin - data_margen);
  if ymin<0 then ymin := ymin -1;
  writeln('  Range of data with ',data_margen:3:1,' km margin:');
  writeln('     x-coordinate: ',xmin:5:0,' - ',xmax:3:0,' km');
  writeln('     y-coordinate: ',ymin:5:0,' - ',ymax:3:0,' km');
  if (xmax-xmin)> (ymax-ymin) then ymax := ymin + (xmax-xmin)
  else                             xmax := xmin + (ymax-ymin);
  writeln('  Range of data with ',data_margen:3:1,' km margin and equal scale:');
  writeln('     x-coordinate: ',xmin:5:0,' - ',xmax:3:0,' km');
  writeln('     y-coordinate: ',ymin:5:0,' - ',ymax:3:0,' km');
  close(infile);

  if paramcount<2 then begin
    write  ('   Do you want to change x- or y-coordinates ? (y/n): ' );
    readln(ch1);
    if (ch1='y') or (ch1='Y') then begin
      ch1 := 'n';
      repeat
        write('  Enter min. resp. max. value of x-coordinate: ');
        readln(xmin,xmax);
        write('  Enter min. resp. max. value of y-coordinate: ');
        readln(ymin,ymax);
        if (xmax-xmin)<>(ymax-ymin) then begin
          writeln('   X- amd Y-axis are not equaly scaled !!');
          write  ('   Do you want to change x- or y-coordinates ? (y/n): ' );
          readln(ch1);
        end;
      until (ch1<>'y') and (ch1<>'Y');
    end;

    write('  Date on plot ? (y/n): ');
    readln(ch1);
    Suppl_txt := false;
    if (ch1='y') or (ch1='Y') then Suppl_txt := true;
  end else if (paramstr(3)<>'a') and (paramstr(3)<>'A') then begin
    if (paramstr(2)='y') or (paramstr(2)='Y') then Suppl_txt:= true;
    val(paramstr(3),xmin,code);
    val(paramstr(4),xmax,code);
    val(paramstr(5),ymin,code);
    val(paramstr(6),ymax,code);
  end;

  assign(infile,'xyplot.std');
  reset(InFile);
  assign(outfile,'xyplot.grf');
  rewrite(outfile);

  readln(InFile,Str);
  writeln(outfile,Str);
  readln(InFile,Str);
  if Suppl_txt=true then  writeln(outfile,'3 2 2 0 0')
  else                      writeln(outfile,'3 2 1 0 0');

  for i := 1 to 23 do begin
    readln(InFile,Str);
    writeln(outfile,Str);
  end;
  readln(InFile);
  writeln(outfile,xmin:15:1,xmax:15:1,' 9.9000000e+028 1 1');
  for i := 1 to 7 do begin
    readln(InFile,Str);
    writeln(outfile,Str);
  end;
  readln(InFile);
  writeln(outfile,ymin:15:1,ymax:15:1,' 9.9000000e+028 1 1');
  for i := 1 to 9 do begin
    readln(InFile,Str);
    writeln(outfile,Str);
  end;
  readln(InFile,Str);
  writeln(outfile,'0 22 "Date: ',date:6,'  Hour: ',hour:2,'"'); {data date}

  if Suppl_txt=true then begin
    for i := 1 to 4  do begin
      readln(InFile,Str);
      writeln(outfile,Str);
    end;
    GetDate(yy,mm,dd,daguge);                              {current date}
    readln(InFile);
    write(outfile,'0 20 "');
    if mm < 10 then
         writeln(outfile,'NERI, PL (',dd:2,'/',mm:1,'-',yy-1900:2,') "')
    else writeln(outfile,'NERI, PL (',dd:2,'/',mm:2,'-',yy-1900:2,')"');
  end;

  close(outfile);
  close(infile);
end.
